﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;
using System.Xml;
using System.Xml.Serialization;

namespace ConsoleApplication1
{
    class Program
    {
        static void Main(string[] args)
        {
            var one = new int[10] { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
            var two = new ArrayList();
            for (int i = 0; i < 10; i++)
            {
                two.Add(i);
            }

            var three = new List<int> { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9 };
            var four = new LinkedList<int>();
            for (int i = 0; i < 10; i++)
            {
                four.AddLast(i);
            }

            var five = new Dictionary<string, int>() { { "A", 1 }, { "B", 2 }, { "C", 3 }, { "D", 4 }, { "E", 5 } };

            Console.WriteLine(Serialise(one));
            Console.WriteLine(Serialise(two));
            Console.WriteLine(Serialise(three));
            //Console.WriteLine(Serialise(four)); <- Fails            
            //Console.WriteLine(Serialise(five)); <- Fails
            Console.WriteLine(Serialise2(one));
            Console.WriteLine(Serialise2(two));
            Console.WriteLine(Serialise2(three));
            Console.WriteLine(Serialise2(four)); 
            Console.WriteLine(Serialise2(five)); 
        }

        private static string Serialise<T>(T o)
        {
            var serializer = new XmlSerializer(typeof(T));
            var memoryStream = new MemoryStream();
            serializer.Serialize(memoryStream, o);
            memoryStream.Position = 0;
            using (var reader = new StreamReader(memoryStream))
            {
                return reader.ReadToEnd();
            }
        }

        class LinkedListWriter : TextWriter
        {
            public override Encoding Encoding
            {
                get { return Encoding.Unicode; }
            }

            public override void Write(int value)
            {
                base.Write(value);
            }
        }


        private static string Serialise2<T>(T o)
        {
            var serializer = new DataContractSerializer(typeof(T));
            var memoryStream = new MemoryStream();
            serializer.WriteObject(memoryStream, o);
            memoryStream.Position = 0;
            using (var reader = new StreamReader(memoryStream))
            {
                return reader.ReadToEnd();
            }
        }
    }
}
